/// <summary> /// Implement this method as an external command for Revit. /// </summary> /// <param name="commandData">An object that is passed to the external application /// which contains data related to the command, /// such as the application object and active view.</param> /// <param name="message">A message that can be set by the external application /// which will be displayed if a failure or cancellation is returned by /// the external command.</param> /// <param name="elements">A set of elements to which the external application /// can add elements that are to be highlighted in case of failure or cancellation.</param> /// <returns>Return the status of the external command. /// A result of Succeeded means that the API external method functioned as expected. /// Cancelled can be used to signify that the user cancelled the external operation /// at some point. Failure should be returned if the application is unable to proceed with /// the operation.</returns> public Autodesk.Revit.UI.Result Execute(Autodesk.Revit.UI.ExternalCommandData commandData, ref string message, Autodesk.Revit.DB.ElementSet elements) { Transaction newTran = null; try { if (null == commandData) { throw new ArgumentNullException("commandData"); } Document doc = commandData.Application.ActiveUIDocument.Document; ViewsMgr view = new ViewsMgr(doc); newTran = new Transaction(doc); newTran.Start("AllViews_Sample"); AllViewsForm dlg = new AllViewsForm(view); if (dlg.ShowDialog() == DialogResult.OK) { view.GenerateSheets(doc); } newTran.Commit(); return(Autodesk.Revit.UI.Result.Succeeded); } catch (Exception e) { // message = e.Message; if (e.Message == "viewId cannot be added to the ViewSheet." + Environment.NewLine + "Parameter name: viewId") { TaskDialog.Show("Error", "Cannot reuse the same view"); } else { message = e.Message; } if ((newTran != null) && newTran.HasStarted() && !newTran.HasEnded()) { newTran.RollBack(); } return(Autodesk.Revit.UI.Result.Failed); } }
/// <summary> /// constructor /// </summary> /// <param name="data"></param> public AllViewsForm(ViewsMgr data) { m_data = data; InitializeComponent(); }